#!/bin/sh
exec perl -x $0 $@

#!perl
#Copyright (C) 1999 Jukka Zitting <jukka.zitting@iki.fi>
#Copyright (C) 2000 The Midgard Project ry
#Copyright (C) 2000 Emile Heyns, Aurora SA <emile@iris-advies.com>
#
#This program is free software; you can redistribute it and/or modify it
#under the terms of the GNU Lesser General Public License as published
#by the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use Getopt::Std;

getopts('ch');

$commonprefix = "MGD_AUTH_";

$errcodes=<<EOERRS;

ANONYMOUS				Anonymous login
NOT_CONNECTED			Not connected to midgard database
INVALID_NAME			Invalid characters in username
REAUTH					Stacked re-authentication not allowed
SG_NOTFOUND				Sitegroup does not exist
DUPLICATE				Username found more than once
NOTFOUND					Username not found
INVALID_PWD				Invalid characters in password

EOERRS

###################################################################

use Getopt::Std;

foreach (split(/\n/, $errcodes)) {
	($name, $comment) = /([A-Z][_A-Z0-9]*)\t+(.*)/;
	if (!$name) {
		($name, $value) = /([A-Z][_A-Z0-9]*)/;
	}
	$name || next;

	$comment =~ s/"/\\"/;

	$name = "$commonprefix$name";

	if (! $comment ) { $comment = $name; }

	push @names, $name;
	$defines{$name} = -$#names;
	$comments{$name} = $comment;
}

if ($opt_h) {
	print "/* Emile Heyns (http://www.midgard-project.org/): DO NOT EDIT! */\n";
	print "/* This is a generated files. Changes will simply be overwritten */\n";
	print "/* in the next update */\n";
	print "#ifndef MGD_AUTHFAILURE_H\n#define MGD_AUTHFAILURE_H\n\n";

	foreach (@names) {
		print "#define $_ $defines{$_}\n";
	}
	print "\n";
   print "#define VALID_MGD_AUTH_CODE(x) (((x) <= 0) && ((x) >= " , -$#names, "))\n\n";

	print "extern const char *mgd_authfailure_msg["."];\n";
	print "\n#endif\n";
}

if ($opt_c) {
	print "/* Emile Heyns (http://www.midgard-project.org/): DO NOT EDIT! */\n";
	print "/* This is a generated files. Changes will simply be overwritten */\n";
	print "/* in the next update */\n";
	print "#include <stdlib.h>\n\n";
	print "const char *mgd_authfailure_msg["."] = {\n";
	foreach (@names) {
		print "\t\t\"$comments{$_}\",\n";
	}
	print "\t\tNULL\n};\n";
}

