/* $Id: read.h,v 1.5 2002/09/12 16:29:57 daniel Exp $
 *
 * repligard: Replication utility for Midgard databases.
 * ---------:
 *      read: read Repligard file and calls update logic
 *
 * Copyright (C) 2000 The Midgard Project Ry
 * Copyright (C) 2000 Alexander Bokovoy - Aurora S.A.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _REPLIGARD_READ_H_
#define _REPLIGARD_READ_H_

#ifdef WIN32
#include <windows.h>
#endif
#include <glib.h>
#include "midgard/midgard.h"
#include "schema.h"
#include "common.h"

#ifdef __cplusplus
extern "C"
{
#endif				/* __cplusplus */

#define R_TAG_READ_DB "Database"
#define R_ATT_READ_ID   "id"
#define R_ATT_READ_CHANGED   "changed"
#define R_ATT_READ_DELETED   "deleted"

  void repligard_import_xml (midgard * mgd, RSchemaCfg * schemacfg,
			     GHashTable * guid_hash, const gchar * filename);

#ifdef __cplusplus
}
#endif				/* __cplusplus */

#endif				/* _REPLIGARD_READ_H_ */
